%define build_neonxml 1
%{?_without_neonxml: %global build_neonxml 0}
%{?_with_neonxml: %global build_neonxml 1}

%define build_doc 0
%{?_without_doc: %global build_doc 0}
%{?_with_doc: %global build_doc 1}

%define	major 1
%define libname	%mklibname upsclient %{major}

Summary:	Network UPS Tools Client Utilities
Name:		nut
Version:	2.6.5
Release:	%mkrel 5
Epoch:		1
License:	GPLv2
Group:		System/Kernel and hardware
URL:		http://www.networkupstools.org/
Source0:	http://www.networkupstools.org/source/2.6/%{name}-%{version}.tar.gz
Source1:	http://www.networkupstools.org/source/2.6/%{name}-%{version}.tar.gz.sig
Source4:	nut-client.tmpfiles
Patch0:		nut-upsset.conf.diff
Patch1:		nut-mdv_conf.diff
Patch2:		nut-mageia-add.patch
Patch3:		nut-2.6.5-quickfix.patch
Patch4:		nut-2.6.3-tmpfiles.patch
Patch5:		nut-2.6.5-ipmifix.patch
Requires(pre):	rpm-helper
Requires(post):	rpm-helper
Requires(postun):	rpm-helper
Requires(preun):	rpm-helper
BuildRequires:	freetype2-devel
BuildRequires:	genders-devel
BuildRequires:	libgd-devel >= 2.0.5
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	libtool-devel
BuildRequires:	libusb-devel
BuildRequires:	net-snmp-devel
BuildRequires:	openssl-devel
BuildRequires:	pkgconfig
BuildRequires:	powerman-devel
BuildRequires:	tcp_wrappers-devel
BuildRequires:	xpm-devel
BuildRequires:	avahi-core-devel
BuildRequires:	avahi-client-devel
BuildRequires:	freeipmi-devel
%if %{build_neonxml}
BuildRequires:	neon-devel >= 0.25.0
%endif
%if %{build_doc}
BuildRequires:	dblatex
BuildRequires:	asciidoc >= 8.6.3
%endif

%description
These programs are part of a developing project to monitor the assortment of
UPSes that are found out there in the field. Many models have serial ports of
some kind that allow some form of state checking. This capability has been
harnessed where possible to allow for safe shutdowns, live status tracking on
web pages, and more.

This package includes the client utilities that are required to monitor a UPS
that the client host is powered from - either connected directly via a serial
port (in which case the nut-server package needs to be installed on this
machine) or across the network (where another host on the network monitors the
UPS via serial cable and runs the main nut package to allow clients to see the
information).

%package -n	%{libname}
Summary:	Network UPS Tools Client Utilities library
Group:          System/Libraries

%description -n	%{libname}
These programs are part of a developing project to monitor the assortment of
UPSes that are found out there in the field. Many models have serial ports of
some kind that allow some form of state checking. This capability has been
harnessed where possible to allow for safe shutdowns, live status tracking on
web pages, and more.

This package contains the shared libraries for NUT client applications.

%package	server
Summary:	Network UPS Tools server
Group:		System/Servers
Requires:	nut >= %{epoch}:%{version}-%{release}
Requires(pre):	nut >= %{epoch}:%{version}-%{release}
Requires(pre):	rpm-helper >= 0.8
Requires:	tcp_wrappers

%description	server
These programs are part of a developing project to monitor the assortment of
UPSes that are found out there in the field. Many models have serial ports of
some kind that allow some form of state checking. This capability has been
harnessed where possible to allow for safe shutdowns, live status tracking on
web pages, and more.

This package is the main NUT upsd daemon and the associated per-UPS-model
drivers which talk to the UPSes. You also need to install the base NUT package.

%package	cgi
Summary:	CGI utils for NUT
Group:		Monitoring
Requires:	apache
Conflicts:	apcupsd

%description	cgi
These programs are part of a developing project to monitor the assortment of
UPSes that are found out there in the field. Many models have serial ports of
some kind that allow some form of state checking. This capability has been
harnessed where possible to allow for safe shutdowns, live status tracking on
web pages, and more.

This package adds the web CGI programs. These can be installed on a separate
machine to the rest of the NUT package.

%package	devel
Summary:	Development for NUT Client
Group:		Development/C
Requires(pre):	rpm-helper >= 0.8
Requires:	%{libname} >= %{epoch}:%{version}

%description	devel
These programs are part of a developing project to monitor the assortment of
UPSes that are found out there in the field. Many models have serial ports of
some kind that allow some form of state checking. This capability has been
harnessed where possible to allow for safe shutdowns, live status tracking on
web pages, and more.

This package contains the development header files and libraries
necessary to develop NUT client applications.

%prep

%setup -q
%patch0 -p0 -b .upsset.conf
%patch1 -p1 -b .mdv_conf
%patch2 -p0 
%patch3 -p1
%patch4 -p1
%patch5 -p1

# instead of a patch
perl -pi -e "s|/cgi-bin/nut/||g" data/html/*.html*

%build
# this takes care of rpath
#libtoolize --copy --force; aclocal -I m4; autoconf; automake --foreign --add-missing --copy

%serverbuild

autoreconf -i
%configure2_5x \
    --with-all \
    --with-libltdl \
    --without-hal \
    --with-cgi \
    --disable-static \
    --sysconfdir=%{_sysconfdir}/ups \
%if %{build_neonxml}
    --with-neon \
%endif
%if %{build_doc}
    --with-doc \
%endif
    --with-statepath=/var/state/ups \
    --with-drvpath=/sbin \
    --with-cgipath=%{_libdir}/nut \
    --with-htmlpath=%{_libdir}/nut \
    --with-pidpath=/run/nut \
    --with-port=3493 \
    --with-user=ups \
    --with-group=ups \
    --with-systemdsystemunitdir=%{_unitdir} \
    --with-pkgconfig-dir=%{_libdir}/pkgconfig \
    --with-udev-dir=/lib/udev

%make

%install
%makeinstall_std

install -d %{buildroot}/var/state/ups

# move the *.sample config files to their real locations
for file in %{buildroot}%{_sysconfdir}/ups/*.sample; do
    mv $file %{buildroot}%{_sysconfdir}/ups/`basename $file .sample`
done

perl -pi \
    -e 's/# RUN_AS_USER nutmon/RUN_AS_USER ups/g' \
    %{buildroot}%{_sysconfdir}/ups/upsmon.conf

# restrict some permissions on configuration files
chmod 640 %{buildroot}%{_sysconfdir}/ups/upssched.conf
chmod 640 %{buildroot}%{_sysconfdir}/ups/upsmon.conf
chmod 640 %{buildroot}%{_sysconfdir}/ups/upsd.users
chmod 640 %{buildroot}%{_sysconfdir}/ups/upsd.conf


install -D -m 644 %{SOURCE4} %{buildroot}%{_prefix}/lib/tmpfiles.d/nut-client.conf

cp -af data/driver.list docs/

# udev usb ups stuff
mv %{buildroot}/lib/udev/rules.d/52-nut-usbups.rules \
    %{buildroot}/lib/udev/rules.d/70-nut-usbups.rules
mv %{buildroot}/lib/udev/rules.d/52-nut-ipmipsu.rules \
    %{buildroot}/lib/udev/rules.d/70-nut-ipmipsu.rules

# fix access config files
install -d %{buildroot}%{_webappconfdir}
cat > %{buildroot}%{_webappconfdir}/%{name}-cgi.conf << EOF

Alias /nut %{_libdir}/nut

<Directory %{_libdir}/nut>
    Require local granted
    AddHandler cgi-script .cgi
    Options +ExecCGI
</Directory>
EOF

# cleanup
rm -f %{buildroot}%{_sysconfdir}/ups/nut.conf

find %{buildroot} -name '*.la' -delete

%pre
# Create a UPS user
%_pre_useradd ups /var/state/ups /bin/false
%{_sbindir}/usermod -G dialout,tty,usb ups

%preun
# only do this if it is not an upgrade
%_preun_service upsmon

%post
%_post_service upsmon

%postun
# Only do this if it is not an upgrade
if [ ! -f %_sbindir/upsd ]; then
   %_postun_userdel ups
fi

%pre	server
# Create a UPS user. We do not use the buggy macro %_pre_groupadd anymore.
%_pre_useradd ups /var/state/ups /bin/false
%{_sbindir}/usermod -G dialout,tty,usb ups

%preun	server
%_preun_service upsd || :

%post	server
%_post_service upsd || :

%postun	server
# Only do this if it is not an upgrade
if [ ! -f %_sbindir/upsmon ]; then
   %_postun_userdel ups
fi

%files
%doc AUTHORS COPYING ChangeLog MAINTAINERS NEWS README UPGRADING docs
%dir %{_sysconfdir}/ups
%{_unitdir}/nut-monitor.service
%{_prefix}/lib/tmpfiles.d/nut-client.conf
%attr(-,root,ups) %config(noreplace) %{_sysconfdir}/ups/upssched.conf
%attr(-,root,ups) %config(noreplace) %{_sysconfdir}/ups/upsmon.conf
%attr(-,ups,ups) %dir /var/state/ups
%{_bindir}/upsc
%{_bindir}/upscmd
%{_bindir}/nut-scanner
%{_bindir}/upslog
%{_bindir}/upsrw
%{_bindir}/upssched-cmd
%{_sbindir}/upsmon
%{_sbindir}/upssched
%{_mandir}/man5/upsmon.conf.5*
%{_mandir}/man5/upssched.conf.5*
%{_mandir}/man8/upsc.8*
%{_mandir}/man8/upscmd.8*
%{_mandir}/man8/upsrw.8*
%{_mandir}/man8/upslog.8*
%{_mandir}/man8/upsmon.8*
%{_mandir}/man8/upssched.8*
%{_mandir}/man8/upsset.cgi.8*
%{_prefix}/lib/systemd/system-shutdown/nutshutdown

%files -n %{libname}
%{_libdir}/*.so.%{major}*

%files server
%{_sbindir}/upsd
%{_unitdir}/nut-driver.service
%{_unitdir}/nut-server.service
%config(noreplace) %{_sysconfdir}/ups/ups.conf
%attr(-,root,ups) %config(noreplace) %{_sysconfdir}/ups/upsd.users
%attr(-,root,ups) %config(noreplace) %{_sysconfdir}/ups/upsd.conf
/lib/udev/rules.d/70-nut-usbups.rules
/lib/udev/rules.d/70-nut-ipmipsu.rules
/sbin/apcsmart
/sbin/apcsmart-old
/sbin/bcmxcp
/sbin/bcmxcp_usb
/sbin/belkin
/sbin/belkinunv
/sbin/bestfcom
/sbin/bestfortress
/sbin/bestuferrups
/sbin/bestups
/sbin/blazer_ser
/sbin/blazer_usb
/sbin/clone
/sbin/clone-outlet
/sbin/dummy-ups
/sbin/etapro
/sbin/everups
/sbin/gamatronic
/sbin/genericups
/sbin/isbmex
/sbin/ivtscd
/sbin/liebert
/sbin/liebert-esp2
/sbin/masterguard
/sbin/metasys
/sbin/mge-shut
/sbin/mge-utalk
/sbin/microdowell
/sbin/nut-ipmipsu
/sbin/oldmge-shut
/sbin/oneac
/sbin/optiups
/sbin/powercom
/sbin/powerman-pdu
/sbin/powerpanel
/sbin/rhino
/sbin/richcomm_usb
/sbin/safenet
/sbin/skel
/sbin/snmp-ups
/sbin/solis
/sbin/tripplite
/sbin/tripplitesu
/sbin/tripplite_usb
/sbin/upscode2
/sbin/upsdrvctl
/sbin/usbhid-ups
/sbin/victronups
%if %{build_neonxml}
/sbin/netxml-ups
%endif
%{_datadir}/cmdvartab
%{_datadir}/driver.list
%{_mandir}/man3/nutscan.3*
%{_mandir}/man3/nutscan_add_device_to_device.3*
%{_mandir}/man3/nutscan_add_option_to_device.3*
%{_mandir}/man3/nutscan_cidr_to_ip.3*
%{_mandir}/man3/nutscan_display_parsable.3*
%{_mandir}/man3/nutscan_display_ups_conf.3*
%{_mandir}/man3/nutscan_free_device.3*
%{_mandir}/man3/nutscan_init.3*
%{_mandir}/man3/nutscan_new_device.3*
%{_mandir}/man3/nutscan_scan_avahi.3*
%{_mandir}/man3/nutscan_scan_ipmi.3*
%{_mandir}/man3/nutscan_scan_nut.3*
%{_mandir}/man3/nutscan_scan_snmp.3*
%{_mandir}/man3/nutscan_scan_usb.3*
%{_mandir}/man3/nutscan_scan_xml_http.3*
%{_mandir}/man5/nut.conf.5*
%{_mandir}/man5/ups.conf.5*
%{_mandir}/man5/upsd.conf.5*
%{_mandir}/man5/upsd.users.5*
%{_mandir}/man8/apcsmart.8*
%{_mandir}/man8/apcsmart-old.8*
%{_mandir}/man8/bcmxcp.8*
%{_mandir}/man8/bcmxcp_usb.8*
%{_mandir}/man8/belkin.8*
%{_mandir}/man8/belkinunv.8*
%{_mandir}/man8/bestfcom.8*
%{_mandir}/man8/bestfortress.8*
%{_mandir}/man8/bestuferrups.8*
%{_mandir}/man8/bestups.8*
%{_mandir}/man8/blazer.8*
%{_mandir}/man8/clone.8*
%{_mandir}/man8/dummy-ups.8*
%{_mandir}/man8/etapro.8*
%{_mandir}/man8/everups.8*
%{_mandir}/man8/gamatronic.8*
%{_mandir}/man8/genericups.8*
%{_mandir}/man8/isbmex.8*
%{_mandir}/man8/ivtscd.8*
%{_mandir}/man8/liebert.8*
%{_mandir}/man8/liebert-esp2.8*
%{_mandir}/man8/masterguard.8*
%{_mandir}/man8/metasys.8*
%{_mandir}/man8/mge-shut.8*
%{_mandir}/man8/mge-utalk.8*
%{_mandir}/man8/microdowell.8*
%{_mandir}/man8/nutupsdrv.8*
%{_mandir}/man8/nut-ipmipsu.8*
%{_mandir}/man8/nut-recorder.8*
%{_mandir}/man8/nut-scanner.8*
%{_mandir}/man8/oneac.8*
%{_mandir}/man8/optiups.8*
%{_mandir}/man8/powercom.8*
%{_mandir}/man8/powerman-pdu.8*
%{_mandir}/man8/powerpanel.8*
%{_mandir}/man8/rhino.8*
%{_mandir}/man8/richcomm_usb.8*
%{_mandir}/man8/safenet.8*
%{_mandir}/man8/snmp-ups.8*
%{_mandir}/man8/solis.8*
%{_mandir}/man8/tripplite.8*
%{_mandir}/man8/tripplitesu.8*
%{_mandir}/man8/tripplite_usb.8*
%{_mandir}/man8/upscode2.8*
%{_mandir}/man8/upsd.8*
%{_mandir}/man8/upsdrvctl.8*
%{_mandir}/man8/usbhid-ups.8*
%{_mandir}/man8/victronups.8*
%if %{build_neonxml}
%{_mandir}/man8/netxml-ups.8*
%endif

%files cgi
%config(noreplace) %{_sysconfdir}/ups/hosts.conf
%config(noreplace) %{_sysconfdir}/ups/upsset.conf
%config(noreplace) %{_sysconfdir}/ups/upsstats.html
%config(noreplace) %{_sysconfdir}/ups/upsstats-single.html
%config(noreplace) %{_webappconfdir}/%{name}-cgi.conf
%{_libdir}/nut
%{_mandir}/man5/hosts.conf.5*
%{_mandir}/man5/upsstats.html.5*
%{_mandir}/man5/upsset.conf.5*
%{_mandir}/man8/upsimage.cgi.8*
%{_mandir}/man8/upsset.cgi.8*
%{_mandir}/man8/upsstats.cgi.8*

%files devel
%{_includedir}/*.h
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man3/upscli_*.3*
%{_mandir}/man3/upsclient.3*


%changelog

* Wed Jan 23 2013 fwang <fwang> 1:2.6.5-5.mga3
+ Revision: 391295
- update rpm group

* Sat Jan 12 2013 umeabot <umeabot> 1:2.6.5-4.mga3
+ Revision: 361082
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Dec 01 2012 pterjan <pterjan> 1:2.6.5-3.mga3
+ Revision: 324541
- Add Fedora patch to build with recent freeipmi

  + luigiwalser <luigiwalser>
    - fix owner of /run/nut in tmpfiles config
    - replace undefined macro

  + fwang <fwang>
    - rebuild for new freeipmi

* Thu Sep 06 2012 guillomovitch <guillomovitch> 1:2.6.5-1.mga3
+ Revision: 288859
- install www content under %%{_libdir}/nut, and make its configuration compatible with apache 2.4
- hardcode user
- use /run/nut instead of /var/run/nut
- use relevant macro for webapp configuration directory
- cleanup files section
- drop sysinit support
- new version
- add systemd support
- add avahi and ipmi support
- drop hal support
- use /lib/udev instead of /etc/udev for udev rules

* Thu Jul 19 2012 fwang <fwang> 1:2.6.4-2.mga3
+ Revision: 272553
- drop hal support as it is not enabled by default

* Thu Jun 14 2012 luigiwalser <luigiwalser> 1:2.6.4-1.mga3
+ Revision: 260685
- add apcsmart-old to files list
- do not try to build tools that do not build
- 2.6.4 (fix CVE-2012-2944)

* Wed Sep 07 2011 tv <tv> 1:2.6.1-1.mga2
+ Revision: 140359
- fix missing LSB keywords
- new release

  + guillomovitch <guillomovitch>
    - rebuild for latest net-snmp

* Thu Mar 03 2011 ennael <ennael> 1:2.6.0-2.mga1
+ Revision: 63404
- add mageia in list
- clean spec file
- imported package nut

